package com.FranckBarbier.Java.Currency_conversion;

/**
 * Simple Java program to test the currency conversion service offered by
 * https://fixer.io
 *
 * Further info. on this API is here:
 * https://fixer.io/documentation. To work, you must first register
 * and get an application identity.
 */
public class Fixer { // Default base currency is EUR

    private static final String _License_key = "f9ae18a1a70ceef1bbf421ecf494ecb4";

    public static double Convert(Currencies fromCurrency, Currencies toCurrency, double amount) throws java.io.IOException {
        if (fromCurrency == toCurrency) {
            return amount;
        }
        double euro2fromCurrency = 0., euro2toCurrency = 0.;
        // Cheap access for poor people:
        java.net.URL url = new java.net.URL("http://data.fixer.io/api/latest" + "?access_key=" + _License_key);
        java.net.URLConnection connection = (java.net.URLConnection) url.openConnection();
        if (connection != null) {
            javax.json.stream.JsonParserFactory factory = javax.json.Json.createParserFactory(null);
            javax.json.stream.JsonParser parser = factory.createParser(connection.getInputStream());
            while (parser.hasNext()) {
                javax.json.stream.JsonParser.Event event = parser.next();
                if (event == javax.json.stream.JsonParser.Event.KEY_NAME && parser.getString().equals(fromCurrency.currency)) {
                    javax.json.stream.JsonParser.Event event_ = parser.next();
                    assert (event_ == javax.json.stream.JsonParser.Event.VALUE_NUMBER);
                    euro2fromCurrency = Double.parseDouble(parser.getString());
                }
                if (event == javax.json.stream.JsonParser.Event.KEY_NAME && parser.getString().equals(toCurrency.currency)) {
                    javax.json.stream.JsonParser.Event event_ = parser.next();
                    assert (event_ == javax.json.stream.JsonParser.Event.VALUE_NUMBER);
                    euro2toCurrency = Double.parseDouble(parser.getString());
                }
            }
        }
        return amount * euro2toCurrency / euro2fromCurrency;
    }
}
